#!/usr/bin/ruby
# encoding: utf-8

def get_failure_screen(fwdbutton, simulate)
	icon_theme = Gtk::IconTheme.default
	outer_box = Gtk::VBox.new(true, 10)
	outer_box.set_size_request(570, 220)
	radio = Array.new
	header = Gtk::Label.new("Windows startet nicht richtig oder stürzt ab")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	radio[0] = Gtk::RadioButton.new("Windows startet vollständig, stürzt aber ab oder friert ein")
	radio[1] = Gtk::RadioButton.new(radio[0], "Windows startet nicht, es erscheint \"NTLDR nicht gefunden\"")
	radio[2] = Gtk::RadioButton.new(radio[0], 
		"Windows startet nicht, es erscheint \"No operating system found\" oder \"Please insert a bootable media\"")
	outer_box.pack_start(header, true, true, 0)
	# 0.upto(2) { |i| outer_box.pack_start(radio[i], true, false, 0) }
	
	button = Array.new
	0.upto(2) { |i| 
		button[i] = Gtk::Button.new
		button[i].xalign = 0.0 
	}
	button[0].label = "Windows startet vollständig, stürzt aber ab oder friert ein"
	button[0].image = Gtk::Image.new(icon_theme.load_icon("gnome-monitor", 48, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
	button[1].label = "Windows startet nicht, es erscheint \"NTLDR nicht gefunden\""
	button[1].image = Gtk::Image.new(icon_theme.load_icon("help-browser", 48, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
	b2l = Gtk::Label.new "Windows startet nicht, es erscheint \"No operating system found\" oder \"Please insert a bootable media\""
	b2l.wrap = true
	lbx = Gtk::Alignment.new(0.0, 0.0, 1.0, 1.0)
	lbx.add b2l
	# button[2].add b2l
	aux_hb =  Gtk::HBox.new(false, 4)
	aux_hb.pack_start( Gtk::Image.new(icon_theme.load_icon("gtk-floppy", 48, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK)), false, true, 0)
	aux_hb.pack_start( lbx, false, true, 0)
	# button[2].image = Gtk::Image.new(icon_theme.load_icon("system-users", 48, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
	button[2].add aux_hb
	0.upto(2) { |i| outer_box.pack_start(button[i], true, true, 0) }
	return outer_box, radio, button
end

def get_smart_overview_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 5)
	header = Gtk::Label.new("Auslesen des Festplattenzustandes")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	drivebox = Gtk::VBox.new(false, 5)
	scroll_pane = Gtk::ScrolledWindow.new
	scroll_pane.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC)
	scroll_pane.add_with_viewport(drivebox)
	scroll_pane.set_size_request(570, 200)
	all_devices = Array.new
	all_checkboxes = Array.new
	drv_count = 0
	desc = Gtk::Label.new("Klicken Sie auf \"Weiter\", um einen vollständigen Test aller Laufwerke mit SMART-Funktionalität zu starten. Dieser Test kann mehrere Stunden dauern, alle Laufwerke werden jedoch parallel untersucht.")
	desc.width_request = 560
	desc.wrap = true
	lbx = Gtk::Alignment.new(0.0, 0.0, 1.0, 1.0)
	lbx.add desc
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(scroll_pane, true, true, 0)
	outer_box.pack_start(lbx, true, true, 0)
	return outer_box, drivebox
end

def get_smart_progress_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 15)
	header = Gtk::Label.new("Analyse des Festplattenzustandes")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Beim SMART-Selbsttest werden alle Festplatten mit SMART-Funktionalität parallel geprüft. Der gesamte Test kann mehrere Stunden dauern. Sie können die Prüfung jederzeit abbrechen, dann besteht allerdings die Gefahr, dass nicht alle defekten Festplatten erkannt werden.")
	desc.wrap = true
	desc.width_request = 570
	pgbar = Gtk::ProgressBar.new
	pgbar.width_request = 570
	scan_vte = Vte::Terminal.new
	scan_exp = Gtk::Expander.new("Details anzeigen")
	stop_smart_test = Gtk::Button.new("Abbrechen")
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	outer_box.pack_start(pgbar, true, true, 0)
	outer_box.pack_start(stop_smart_test, true, true, 0)
	scan_exp.add(scan_vte)
	### outer_box.pack_start(scan_exp, true, true, 0)
	return outer_box, scan_vte, pgbar, stop_smart_test
end

def get_smart_fail_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 5)
	header = Gtk::Label.new("Defekte Festplatte gefunden")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Bei der Analyse wurden eine oder mehrere Festplatten mit Fehlern gefunden. Um Datenverlusten vorzubeugen, empfehlen wir, den Inhalt der Festplatte jetzt auf eine andere Festplatte zu sichern. Sie können die Sicherung später mit dem Menüpunkt \"Eine zuvor erstellte Sicherung zurückspielen\" auf eine neue Festplatte kopieren. Bitte wählen Sie die Zielplatte aus und klicken Sie dann auf \"Weiter\".")
	desc.wrap = true
	desc.width_request = 570
	drive_combo = Gtk::ComboBox.new
	reread = Gtk::Button.new("Neu einlesen")
	drivebox = Gtk::VBox.new(false, 5)
	scroll_pane = Gtk::ScrolledWindow.new
	scroll_pane.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC)
	scroll_pane.add_with_viewport(drivebox)
	scroll_pane.set_size_request(570, 120)
	## inner_box = Gtk::HBox.new(false, 0)
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	## inner_box.pack_start(drive_combo, true, true, 0)
	## inner_box.pack_start(reread, true, true, 0)
	## outer_box.pack_start(inner_box, true, true, 0)
	outer_box.pack_start(scroll_pane, true, true, 0)
	outer_box.pack_start(reread, true, true, 0)
	return outer_box, drivebox, reread
end

def get_smart_clone_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 15)
	header = Gtk::Label.new("Erstellen einer Datensicherung")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	## desc = Gtk::Label.new("Fortschritt: 42%")
	desc = Gtk::Label.new("Es werden nun alle defekten Festplatten auf die ausgewählten Ziellaufwerke geklont. Dieser Vorgang kann einige Stunden dauern.")
	desc.wrap = true
	desc.width_request = 570
	pgbar = Gtk::ProgressBar.new
	pgbar.width_request = 570
	scan_vte = Vte::Terminal.new
	scan_vte.set_colors(Gdk::Color.new(0,0,0), Gdk::Color.new(65535, 65535, 65535), [])
	scan_vte.set_size(80, 12)
	stop_button = Gtk::Button.new("Abbrechen")
	stop_button.sensitive = false
	### scan_exp = Gtk::Expander.new("Details anzeigen / ausblenden")
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	outer_box.pack_start(pgbar, true, true, 0)
	outer_box.pack_start(scan_vte, true, true, 0)
	outer_box.pack_start(stop_button, true, true, 0)
	
	## scan_exp.add(scan_vte)
	## outer_box.pack_start(scan_exp, true, true, 0)
	return outer_box, scan_vte, pgbar, stop_button
end

def get_smart_finish_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 15)
	header = Gtk::Label.new("Sichern abgeschlossen")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Das KLonen der fehlerhaften Festplatte ist abgeschlossen. Sie können das Ziellaufwerk nun statt der defekten Festplatte in Ihren Computer einbauen oder die Sicherung später zurückspielen. Klicken Sie auf \"Weiter\", um Ihren Computer neu zu starten.")
	desc.wrap = true
	desc.width_request = 570
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	return outer_box
end

def get_smart_ok_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 15)
	header = Gtk::Label.new("Festplattenprüfung abgeschlossen")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Der Festplatten-Selbsttest fand keine Hinweise auf Fehler. Es wird daher veranlasst, dass Windows beim nächsten Start eine Prüfung aller Laufwerke durchführt. Eine weitere mögliche Ursache ist defekter Arbeitsspeicher. Klicken Sie auf \"Weiter\", um einen Test des Arbeitsspeichers zu starten.")
	desc.wrap = true
	desc.width_request = 570
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	return outer_box
end

def smart_short_summary(drives)
	# if a drive is 
	results = Hash.new
	test_types = Hash.new
	bad_sectors = Hash.new
	reallocated_sectors = Hash.new
	seek_errors = Hash.new
	has_smart = Hash.new
	drives.drive_list.each { |k,v|
		numtests = 0
		test_types[k] = nil
		has_smart[k] = false
		system("smartctl -s on " + k)
		IO.popen("smartctl -c " + k) { |l|
			while l.gets
				line = $_.strip
				has_smart[k] = true if line =~ /START OF READ SMART DATA SECTION/
			end
		}	
		inside = false
		IO.popen("smartctl -l selftest " + k) { |l|
			while l.gets
				line = $_.strip
				if inside == true && line =~/^\#/
					if line =~ /Short offline/ && test_types[k].nil?
						test_types[k] = "short"
					end
					if (line =~ /Extended offline/ || line =~ /Extended captive/) \
							&& (test_types[k].nil? || test_types[k] == "short") 
						test_types[k] = "long"
					end
					if line =~ /Completed\: read failure/
						results[k] = "error"
					end
				end
				inside = true if line =~ /START OF READ SMART DATA SECTION/
			end
		}
		inside = false
		IO.popen("smartctl --attributes " + k) { |l|
			while l.gets
				line = $_.strip
				ltoks = line.split
				if inside == true && ltoks[0].to_i == 5 && ltoks[-1].to_i > 0
					reallocated_sectors[k] = ltoks[-1].to_i
				elsif inside == true && ltoks[0].to_i == 7 && ltoks[-1].to_i > 100
					seek_errors[k] = ltoks[-1].to_i
				elsif inside == true && ltoks[0].to_i == 197 && ltoks[-1].to_i > 0
					bad_sectors[k] = ltoks[-1].to_i
				end
				inside = true if line =~ /^ID\# ATTRIBUTE/
			end
		}
		
	}
	return results, has_smart, test_types, bad_sectors, reallocated_sectors, seek_errors
end

def fill_smart_info(drives, res, available, types, bad, reallocated, seek, panel)
	fat_font = Pango::FontDescription.new("Sans Bold")
	icon_theme = Gtk::IconTheme.default
	panel.each { |c| panel.remove(c) }
	drives.drive_list.keys.sort.each { |k|
		v = drives.drive_list[k]
		puts v.vendor.to_s + " " + v.model.to_s + " " + (v.blocks * v.bs / 1024 / 1024 ).to_s + "MB " + v.device.to_s
		l = Gtk::Label.new(v.vendor.to_s + " " + v.model.to_s + " " + (v.blocks * v.bs / 1024 / 1024 ).to_s + "MB " + v.device.to_s )
		# l = Gtk::Label.new "Hulla"
		l.modify_font(fat_font)
		panel.pack_start(l, false, true, 5)
		ltext = Array.new
		face = "face-uncertain"
		if available[k] == false
			ltext.push "Dieses Laufwerk verfügt über keine SMART-Funktionalität."
		else
			if types[k].nil?
				ltext.push "Dieses Laufwerk verfügt über SMART-Funktionalität, aber es wurde noch nie ein Selbsttest durchgeführt."
			elsif types[k] == "short"
				ltext.push "Dieses Laufwerk verfügt über SMART-Funktionalität, aber es wurden in letzter Zeit nur kurze Selbsttests durchgeführt."
				face = "face-plain"
			elsif types[k] == "long"
				ltext.push "Dieses Laufwerk verfügt über SMART-Funktionalität und es wurden bereits lange Selbsttests durchgeführt."
				face = "face-smile"
			end
			if bad[k].to_i > 0 || reallocated[k].to_i > 0 || seek[k].to_i > 0
				ltext.push "Das Protokoll des Laufwerkes enthält Hinweise auf defekte/realloziierte Sektoren."
				face = "face-sad"
			end
			if res[k] == "error"
				ltext.push "Beim Selbsttest wurden Probleme festgestellt, die auf ein baldiges Ableben der Festplatte hinweisen."
				face = "face-sad"
			end
		end
		hbox = Gtk::HBox.new(false, 5)
		hbox.width_request = 550
		img = Gtk::Image.new(icon_theme.load_icon(face, 32, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
		hbox.pack_start(img, false, true, 0)
		slab = Gtk::Label.new(ltext.join(" "))
		slab.width_request = 480
		slab.wrap = true
		hbox.pack_start(slab, false, true, 0)
		panel.pack_start(hbox, false, true, 5)
	}
end


def run_smart_check(drives, progbar, buttons)
	buttons.each { |b| b.sensitive = false }
	max_duration = -1
	durations = Hash.new
	remaining = Hash.new
	finished = Hash.new
	bad_drives = Hash.new
	drives.drive_list.keys.sort.each { |k|
		v = drives.drive_list[k]
		system("smartctl -s on " + k)
		system("smartctl -X " + k)	
		inside = false
		IO.popen("smartctl -c " + k) { |l|
			while l.gets
				line = $_.strip
				if line =~ /recommended polling time.*\((.*?)\)/ && inside == true
					# puts v.device + " time: " + $1.to_i.to_s
					durations[k] = $1.to_i
					max_duration = $1.to_i if $1.to_i > max_duration
					break
				end
				inside = true if line =~ /Extended self-test routine/
			end
		}
		finished[k] = false
		system("smartctl -t long " + k)
	}	
	sleepcount = 0
	while finished.has_value?(false)
		remtime = -1
		progbar.pulse
		sleep 0.1
		progbar.pulse
		while (Gtk.events_pending?)
			Gtk.main_iteration
		end
		if sleepcount % 100 == 0
			drives.drive_list.keys.sort.each { |k|
				lcount = 0
				test_line = -1
				IO.popen("smartctl -c " + k) { |l|
					while l.gets
						line = $_.strip
						if line =~ /Self-test routine in progress/ 
							test_line = lcount
						end
						if lcount == test_line + 1 && line =~ /(\d*)% of test remaining/
							remaining[k] = $1.to_i
						end
						lcount += 1
					end
				}
				finished[k] = true if test_line < 0
				this_remaining = remaining[k].to_i * durations[k].to_i / 100 
				remtime = this_remaining if this_remaining > remtime
			}
			progbar.text = "Verbleibende Testdauer: ca. " + remtime.to_s + " Minuten"
		end
		sleepcount += 1
	end
	results, has_smart, test_types, bad_sectors, reallocated_sectors, seek_errors = smart_short_summary(drives)
	results.each { |k,v| bad_drives[k] = drives.drive_list[k] if v == "error" }
	bad_sectors.each { |k,v| bad_drives[k] = drives.drive_list[k] if v > 0 }
	reallocated_sectors.each { |k,v| bad_drives[k] = drives.drive_list[k] if v > 0 }
	seek_errors.each { |k,v| bad_drives[k] = drives.drive_list[k] if v > 0 }
	progbar.fraction = 1.0
	progbar.text = "Der Selbsttest ist abgeschlossen"
	buttons.each { |b| b.sensitive = true }
	return bad_drives
end

def fill_smart_clone_panel(panel, drives, bad_drives)
	# panel.each { |c| panel.remove(c) }
	fat_font = Pango::FontDescription.new("Sans Bold")
	tgt_drives = Hash.new
	tgt_combos = Hash.new
	src_checks = Hash.new
	bad_drives.each { |k,v|
		puts "bad drive: " + k
		lab = Gtk::Label.new(v.vendor.to_s + " " + v.model.to_s + " " + (v.blocks * v.bs / 1024 / 1024 ).to_s + "MB " + v.device)
		lab.modify_font(fat_font)
		panel.pack_start(lab, false, true, 5)
		cb = Gtk::CheckButton.new("Diese Festplatte klonen - Auswahl des Ziellaufwerkes:")
		src_checks[k] = cb
		hbox = Gtk::HBox.new(false, 0)
		panel.pack_start(cb, false, true, 5)
		tgt_combo = Gtk::ComboBox.new
		tgt_drives[k] = Array.new
		drives.drive_list.each { |d,e|
			unless bad_drives.has_key?(d) || v.blocks * v.bs > e.blocks * e.bs 
				puts "target: " + d
				desc = e.vendor.to_s + " " + e.model.to_s + " " + (e.blocks * e.bs / 1024 / 1024 ).to_s + "MB " + e.device
				if e.attached == "usb"
					desc += " (USB)" 
				else
					desc += " (SATA/eSATA/IDE)"
				end
				tgt_combo.append_text(desc)
				tgt_drives[k].push(e.device)
			end
		}
		tgt_combo.active = 0
		tgt_combos[k] = tgt_combo
		panel.pack_start(tgt_combo, false, true, 5)
	}
	return src_checks, tgt_drives, tgt_combos 
	
end

def update_smart_clone_panel(tgt_combos, drives, bad_drives)
	tgt_drives = Hash.new
	# tgt_combos = Hash.new
	bad_drives.each { |k,v|
		puts "bad drive: " + k
		tgt_drives[k] = Array.new
		99.downto(0) { |i|
			begin
				tgt_combos[k].remove_text(i)
			rescue
			end
		}
		drives.drive_list.each { |d,e|
			unless bad_drives.has_key?(d) || v.blocks * v.bs > e.blocks * e.bs 
				puts "target: " + d
				desc = e.vendor.to_s + " " + e.model.to_s + " " + (e.blocks * e.bs / 1024 / 1024 ).to_s + "MB " + e.device
				if e.attached == "usb"
					desc += " (USB)" 
				else
					desc += " (SATA/eSATA/IDE)"
				end
				tgt_combos[k].append_text(desc)
				tgt_drives[k].push(e.device)
			end
		}
		tgt_combos[k].active = 0
	}
	return tgt_drives
end

def smart_no_src_dialog(parent)
	dialog = Gtk::Dialog.new(
		"Information",
		parent,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ]
	)
	dialog.has_separator = false
	label = Gtk::Label.new("Bitte wählen Sie ein Quelllaufwerk zum Klonen aus!")
	label.wrap = true
	image = Gtk::Image.new(Gtk::Stock::DIALOG_INFO, Gtk::IconSize::DIALOG)

	hbox = Gtk::HBox.new(false, 5)
	hbox.border_width = 10
	hbox.pack_start_defaults(image);
	hbox.pack_start_defaults(label);

	# Add the message in a label, and show everything we've added to the dialog.
	# dialog.vbox.pack_start_defaults(hbox) # Also works, however dialog.vbox
                                          # limits a single item (element).
	dialog.vbox.add(hbox)
	dialog.show_all
	dialog.run
	dialog.destroy
	
end

def smart_no_tgt_dialog(parent)
	dialog = Gtk::Dialog.new(
		"Information",
		parent,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ]
	)
	dialog.has_separator = false
	label = Gtk::Label.new("Bitte stecken Sie ein Ziellaufwerk an, das wenigstens die Größe des defekten Quellaufwerkes hat und klicken Sie anschließend auf \"Neu einlesen\".")
	label.wrap = true
	image = Gtk::Image.new(Gtk::Stock::DIALOG_INFO, Gtk::IconSize::DIALOG)

	hbox = Gtk::HBox.new(false, 5)
	hbox.border_width = 10
	hbox.pack_start_defaults(image);
	hbox.pack_start_defaults(label);

	# Add the message in a label, and show everything we've added to the dialog.
	# dialog.vbox.pack_start_defaults(hbox) # Also works, however dialog.vbox
                                          # limits a single item (element).
	dialog.vbox.add(hbox)
	dialog.show_all
	dialog.run
	dialog.destroy
end


def smart_mult_tgt_dialog(parent)
	dialog = Gtk::Dialog.new(
		"Information",
		parent,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ]
	)
	dialog.has_separator = false
	label = Gtk::Label.new("Zu mehreren Quelllaufwerken wurde dasselbe Ziellaufwerk ausgewählt! Bitte ändern Sie Ihre Auswahl.")
	label.wrap = true
	image = Gtk::Image.new(Gtk::Stock::DIALOG_INFO, Gtk::IconSize::DIALOG)

	hbox = Gtk::HBox.new(false, 5)
	hbox.border_width = 10
	hbox.pack_start_defaults(image);
	hbox.pack_start_defaults(label);

	# Add the message in a label, and show everything we've added to the dialog.
	# dialog.vbox.pack_start_defaults(hbox) # Also works, however dialog.vbox
                                          # limits a single item (element).
	dialog.vbox.add(hbox)
	dialog.show_all
	dialog.run
	dialog.destroy
end

def smart_run_ddrescue(vte, progbar, srctgt, buttons)
	buttons.each { |b| b.sensitive = false } 
	args = Array.new
	args.push("ruby")
	args.push("run_ddrescue.rb")
	srctgt.each { |k,v|
		args.push(k)
		args.push(v)
		# args.push("/dev/null") 
	}
	ddrunning = true
	vte.signal_connect("child-exited") { ddrunning = false }
	vte.fork_command("ruby", args)
	progbar.text = "Klonen läuft..."
	puts args.join(" ")
	while ddrunning == true
		sleep 0.1
		progbar.pulse
		while (Gtk.events_pending?)
			Gtk.main_iteration
		end
	end
	progbar.text = "Das Klonen ist abgeschlossen."
	progbar.fraction = 1.0
	buttons.each { |b| b.sensitive = true } 
end

def smart_run_ntfsfix(drives)
	drives.drive_list.each { |k,v|
		v.partitions.each { |n,p|
			if p.fs =~ /ntfs/
				puts "Fount ntfs partition: " + p.device
				system("ntfsfix " + p.device)
			end
		}
	}
end

def smart_tgt_not_empty(target, drives)
	puts "not empty? target " + target 
	drives.drive_list.each { |k,v|
		puts "not empty? target " + k
		if target == k
			puts "not empty? occupied " + v.occupied_space.to_s
			if v.occupied_space > 0
				return true
			else
				return false
			end
		end
	}
	return false
end

def smart_tgt_not_empty_dialog(parent, tgt)
	moveon = false
	msg = "Das Ziellaufwerk " + tgt + " ist nicht ganz leer. Drücken Sie \"Abbrechen\", um eine andere Festplatte auszuwählen oder die auf dieser Festplatte enthaltenen Daten auf einem anderen Rechner zu sichern. Falls Sie diese Festplatte erneut anschließen, benutzen Sie bitte den Knopf \"Neu einlesen\" um die Laufwerksliste zu aktualisieren."
	dialog = Gtk::Dialog.new(
		"Information",
		parent,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ],
		[ Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL ]	
	)
	dialog.default_response = Gtk::Dialog::RESPONSE_CANCEL
	dialog.has_separator = false
	label = Gtk::Label.new(msg)
	label.wrap = true
	dialog.vbox.add(label)
	dialog.show_all
	dialog.run { |resp|
		if resp == Gtk::Dialog::RESPONSE_OK
			moveon = true
		end
		dialog.destroy
	}
	return moveon	
end

def get_ntldr_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 15)
	header = Gtk::Label.new("NTLDR not found")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Ursache für den Fehler \"NTLDR not found\" sind meist defekte Festplatten oder defekter Arbeitsspeicher. Im weiteren Verlauf wird versucht, die Ursache exakt zu identifizieren. Notieren Sie sich die folgenden Hinweise, um nach Abschluss der Tests den NTLDR mit Hilfe der Windows-Installations-CD neu zu schreiben.")
	desc.wrap = true
	desc.width_request = 570
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	xphead = Gtk::Label.new("Windows XP")
	xphead.modify_font(fat_font)
	visthead = Gtk::Label.new("Windows Vista und Windows 7")
	visthead.modify_font(fat_font)
	xptext = Gtk::Label.new("Blubberblah...")
	xptext.wrap = true
	visttext = Gtk::Label.new("Blubberblah...")
	visttext.wrap = true
	[ xphead, xptext, visthead, visttext ].each { |i|
		outer_box.pack_start(i, true, false, 0)
	}
	return outer_box
end

def get_noos_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 15)
	header = Gtk::Label.new("No operating system found")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Klicken Sie auf \"Weiter\" um die im Master Boot Record enthaltenen Startinformationen wiederherzustellen.")
	desc.wrap = true
	desc.width_request = 570
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	return outer_box
end

def get_noos_repaired_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 15)
	header = Gtk::Label.new("Startinformationen wiederhergestellt")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Die im Master Boot Record enthaltenen Startinformationen wurden wiederhergestellt. Klicken Sie auf \"Weiter\", um den Computer neu zu starten. Sollte nach dem Neustart keine Besserung erkennbar sein, starten Sie diese CD erneut und wählen Sie den Punkt \"Wichtige Daten sind abhanden gekommen\".")
	desc.wrap = true
	desc.width_request = 570
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	return outer_box
end

def get_noos_failure_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 15)
	header = Gtk::Label.new("Wiederherstellung der Startinformationen fehlgeschlagen")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Die Startinformationen konnten nicht wiederhergestellt werden. Ursache ist eine beschädigte Partitionstabelle oder fehlgeschlagener Zugriff auf die als aktiv markierte Partition. Sichern Sie wichtige Daten (beispielsweise im Menüpunkt \"Wichtige Daten sind nicht mehr auffindbar\") und installieren Sie Windows neu. Klicken Sie auf \"Neu starten\", um den Computer neu zu starten.")
	desc.wrap = true
	desc.width_request = 570
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	return outer_box
end