#!/usr/bin/ruby
# encoding: utf-8

require 'gtk2'
require 'vte'
require "rexml/document"
require 'retrieveDriveDetails'
require 'screenStartCheck' 
require 'screenSelectInitial'
require 'functionsSmart'
require 'functionsClone'
require 'functionsClean'
require 'functionsChntpw'
require 'functionsPhotorec'
require 'functionsVirus'

require 'optparse'

@simulate = Array.new
@deco = true
opts = OptionParser.new 
opts.on('-s', '--simulate', :REQUIRED ) { |i| i.split(",").each { |j| @simulate.push(j) } }
opts.on('--no-deco') { @deco = false } 
opts.parse!

## define the order of pages to follow

def page_order(last_page, radio, start_radio, skipstart)
	return 1 if last_page == 0
	if last_page == 1 && radio[0].active?
		return 2
	end
	if last_page == 1 && radio[1].active?
		return 3
	end
	if last_page == 1 && radio[2].active?
		return 4
	end
	if last_page == 1 && radio[3].active? && (check_network == false || @simulate.include?("nonet"))
		return 5
	elsif last_page == 1 && radio[3].active? && check_network == true
		return 14
	end
	if last_page == 1 && radio[4].active?
		return 6
	end
	if last_page == 1 && radio[5].active?
		return 7
	end
	return 8 if last_page == 3
	return 9 if last_page == 8
	return 10 if last_page == 9
	return 11 if last_page == 10
	return 12 if last_page == 4
	return 13 if last_page == 12
	if last_page == 5 && @wlan_interface.nil? # WLAN settings
		return 15
	elsif last_page == 5
		return 14
	end
	# return 15 if last_page == 14
	return 35 if last_page == 14
	# return 16 if last_page == 15
	return 15 if last_page == 35
	return 16 if last_page == 15 && read_scan_summary == false
	return 36 if last_page == 15 && ( @virus_delete.active? == true || @virus_kill.active? == true )
	return 37 if last_page == 15
	return 17 if last_page == 16
	return 18 if last_page == 17
	return 19 if last_page == 6
	return 20 if last_page == 19
	return 21 if last_page == 20
	return 22 if last_page == 7
	return 23 if last_page == 22
	return 24 if last_page == 23
	if last_page == 2 && start_radio[0].active?
		return 25
	elsif last_page == 2 && start_radio[1].active?
		return 31
	elsif last_page == 2 && start_radio[2].active?
		return 32
	end
	return 26 if last_page == 25
	if last_page == 26 && ( @bad_drives.size > 0 || @simulate.include?("smartfail"))
		return 27
	elsif last_page == 26
		return 30
	end
	return 27 if last_page == 26
	return 28 if last_page == 27
	return 29 if last_page == 28
	return 26 if last_page == 31
	### if last_page == 32 && @simulate.include?("ms-sys-success")
	###	return 33
	### els
	if last_page == 32
		return 34
	end
	return 1 if skipstart == true
	return 0
end

# define if buttons back/forw are visible

def back_forw_visible(screen)
	if screen == 1 || screen == 2 || screen == 28
		return false 
	end
	return true
end


window = Gtk::Window.new
window.border_width = 10
window.window_position = Gtk::Window::POS_CENTER_ALWAYS

if @deco == false
	window.deletable = false
	window.decorated = false
	window.allow_grow = false
	window.allow_shrink = false
end
window.title = "NotfallDreinull"
window.signal_connect('delete_event') { false }
window.signal_connect('destroy') { Gtk.main_quit }

screens = Array.new
prog_path = Array.new

# Container for buttons
icon_theme = Gtk::IconTheme.default
buttonbox = Gtk::HBox.new(false, 5)
back_button = Gtk::Button.new("Zurück")
back_button.image = Gtk::Image.new(icon_theme.load_icon("gtk-go-back-ltr", 24, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
forw_button = Gtk::Button.new("Weiter")
forw_button.image = Gtk::Image.new(icon_theme.load_icon("gtk-go-forward-ltr", 24, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
## stop_button = Gtk::Button.new("Abbrechen")
## stop_button.image = Gtk::Image.new(icon_theme.load_icon("gtk-cancel", 24, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
## buttonbox.pack_start_defaults stop_button
buttonbox.pack_start_defaults back_button
buttonbox.pack_start_defaults forw_button
reboot_button = Gtk::Button.new("Neu starten")
reboot_button.signal_connect("clicked") { Gtk.main_quit }
reboot_box = Gtk::HBox.new(false, 5)
reboot_button.image = Gtk::Image.new(icon_theme.load_icon("stock_refresh", 24, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
reboot_box.pack_start_defaults reboot_button
reboot_box.hide_all
bgimg = Gtk::Image.new("NotfallCD30.png")

# container for warnings upon start
screens[0], showstart, skipstart, swap_combo, swap_button = get_start_screen(forw_button, @simulate)
screens[1], radio_buttons, choose_buttons = get_chooser_screen(forw_button, @simulate)
screens[2], radio_failure, button_failure = get_failure_screen(forw_button, @simulate)
screens[3], photorec_combo, photorec_reread = get_photorec_screen(forw_button, @simulate)
screens[4], chntpw_combo  		= get_chntpw_screen(forw_button, @simulate)
screens[5], wlan_combo, wlan_key, skip_wlan = get_virus_screen(forw_button, @simulate)
screens[6], clean_combo, clean_buttons   = get_clean_screen(forw_button, @simulate)
screens[7], rest_source, rest_src_reread = get_restore_screen(forw_button, @simulate)
screens[8], photorec_ftypes, m_ftypes   = get_photorec_types_screen(forw_button, @simulate)
screens[9], photorec_tgt_combo, photorec_tgt_reread = get_photorec_target_screen(forw_button, @simulate)
screens[10], photorec_vte, photorec_prog = get_photorec_prog_screen(forw_button, @simulate)
screens[11] 				= get_photorec_finish_screen(forw_button, @simulate)
screens[12], user_combo   		= get_chntpw_user_screen(forw_button, @simulate)
screens[13]               		= get_chntpw_finish_screen(forw_button, @simulate)
screens[14], upd_vte, upd_progbar      	= get_virus_sig_screen(forw_button, @simulate)
screens[15], scan_vte, scan_progbar	= get_virus_scan_screen(forw_button, @simulate)
screens[16]               		= get_virus_results_screen(forw_button, @simulate)
screens[17], repair_vte   		= get_virus_repair_screen(forw_button, @simulate)
screens[18]               		= get_virus_finish_screen(forw_button, @simulate)
screens[19], drive_box    		= get_clean_drives(forw_button, @simulate)
screens[20], clean_panel 		= get_clean_progress_screen(forw_button, @simulate)
screens[21]               		= get_clean_finish_screen(forw_button, @simulate)
screens[22], rest_targets, rest_tgt_reread = get_restore_target_screen(forw_button, @simulate)
screens[23], restore_vte, rest_tgt_prog, rest_stop = get_restore_progress_screen(forw_button, @simulate)
screens[24]              	 	= get_restore_finish_screen(forw_button, @simulate)
screens[25], smart_panel		= get_smart_overview_screen(forw_button, @simulate)
screens[26], smart_vte, smart_pgbar, smart_stop = get_smart_progress_screen(forw_button, @simulate)
screens[27], smart_clone_panel, smart_tgt_reread = get_smart_fail_screen(forw_button, @simulate)
screens[28], clone_vte, clone_pgbar, clone_stop	= get_smart_clone_screen(forw_button, @simulate)
screens[29]				= get_smart_finish_screen(forw_button, @simulate)
screens[30]				= get_smart_ok_screen(forw_button, @simulate)
screens[31]				= get_ntldr_screen(forw_button, @simulate)
screens[32]				= get_noos_screen(forw_button, @simulate)
screens[33]				= get_noos_repaired_screen(forw_button, @simulate)
screens[34]				= get_noos_failure_screen(forw_button, @simulate)
screens[35], virus_archive, @virus_delete, @virus_kill = get_virus_options_screen
screens[36], virus_del_panel, virus_del_summary	= get_virus_summary_screen
screens[37], virus_list_field		= get_virus_list_screen

clone_source_drives = Array.new
clone_target_drives = Array.new
clone_source_metas = Hash.new
clone_target_metas = Hash.new
clean_checkboxes = Hash.new
clean_pgbars = Hash.new
clean_vtes = Hash.new
chntpw_parts = Array.new 
nt_users = Array.new
photorec_drives = Array.new
photorec_targets = Array.new
smart_src_checks = Hash.new
smart_tgt_drives = Hash.new 
smart_tgt_combos = Hash.new
swap_sticks = Array.new

@bad_drives = Hash.new
@wlan_interface = nil
current_drivelist = nil

fixed = Gtk::Fixed.new
fixed.put(bgimg, 0, 0)
screens.each { |s| fixed.put(s, 15, 110) }
fixed.put(buttonbox, 440, 395)
fixed.put(reboot_box, 490, 395)

window.set_size_request(600, 440)
window.border_width = 0
window.add(fixed)
window.show_all
screens.each { |s| s.hide_all }

current_page = 0
current_page = 1 if skipstart == true
buttonbox.hide_all if current_page == 1
screens[current_page].show_all
reboot_box.hide_all

back_button.signal_connect("clicked") {
	screens.each { |s| s.hide_all }
	screens[1].show_all
	buttonbox.hide_all
	current_page = 1
	prog_path = [ ] 
	back_button.sensitive = true
	forw_button.sensitive = true
}

choose_buttons[0].signal_connect("clicked") {
	next_screen = 2
	moveon = true
	buttonbox.hide_all
	if moveon == true
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		# prog_path.push(next_screen) unless prog_path[-1] == next_screen
	end
}

choose_buttons[1].signal_connect("clicked") {
	next_screen = 3 
	photorec_drives = fill_photorec_combo(photorec_combo, AllDrives.new(false, false, false))
	forw_button.sensitive = true
	forw_button.sensitive = false if photorec_drives.size < 1 
	moveon = true
	buttonbox.show_all
	if moveon == true
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		# prog_path.push(next_screen) unless prog_path[-1] == next_screen
	end
}

choose_buttons[2].signal_connect("clicked") {
	next_screen = 4
	current_drivelist = AllDrives.new(false, false, false)
	sysparts = find_win_sysparts(current_drivelist)
	chntpw_parts = fill_chntpw_combo(chntpw_combo, sysparts) 
	if chntpw_parts.size < 1
		forw_button.sensitive = false
	end
	moveon = true
	buttonbox.show_all
	if moveon == true
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		# prog_path.push(next_screen) unless prog_path[-1] == next_screen
	end
}

choose_buttons[3].signal_connect("clicked") {
	next_screen = 14
	if check_network == false || @simulate.include?("nonet")
		next_screen = 5
		@wlan_interface = fill_wlan_combo(wlan_combo, get_networks)
		skip_wlan.active = true if @wlan_interface.nil?
	end
	moveon = true
	buttonbox.show_all
	if moveon == true && next_screen == 5
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		# prog_path.push(next_screen) unless prog_path[-1] == next_screen
		dialog_nonet(window) if @wlan_interface.nil?
	else
		puts "Geeeh... moving to 14"
		puts "Geeeh... current page " + current_page.to_s
		puts "Geeeh... prog path " + prog_path.join(", ")
		puts "Geeeh... " +  skip_wlan.active?.to_s
		if skip_wlan.active? == false && check_network == false && ( prog_path.include?(5) || current_page == 5 )
			puts "Geeeh... connecting!"
			window_net_connect(window, wlan_combo.active_text, wlan_key.text, [ forw_button, back_button] )
			screens.each { |s| s.hide_all }
			screens[next_screen].show_all
			prog_path.push(current_page) unless prog_path[-1] == current_page
			current_page = next_screen
			puts prog_path.join(" - ") + " + " + current_page.to_s
			run_virus_signature_update(upd_vte, upd_progbar, [ forw_button, back_button], "kaspersky")
		elsif skip_wlan.active? == true
			next_screen = 15
		else
			buttonbox.hide_all
			screens.each { |s| s.hide_all }
			screens[next_screen].show_all
			prog_path.push(current_page) unless prog_path[-1] == current_page
			current_page = next_screen
			puts prog_path.join(" - ") + " + " + current_page.to_s
			run_virus_signature_update(upd_vte, upd_progbar, [ forw_button, back_button], "kaspersky")
			next_screen = 35
			buttonbox.show_all
			screens.each { |s| s.hide_all }
			screens[next_screen].show_all
			prog_path.push(current_page) unless prog_path[-1] == current_page
			current_page = next_screen
			puts prog_path.join(" - ") + " + " + current_page.to_s
		end
	end
}

choose_buttons[4].signal_connect("clicked") {
	next_screen = 6
	moveon = true
	buttonbox.hide_all
	if moveon == true
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		# prog_path.push(next_screen) unless prog_path[-1] == next_screen
	end
}

choose_buttons[5].signal_connect("clicked") {
	next_screen = 7
	clone_source_drives, clone_source_metas = reread_full_drives(rest_source, [])
	moveon = true
	buttonbox.show_all
	if moveon == true
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		# prog_path.push(next_screen) unless prog_path[-1] == next_screen
	end
}

button_failure[0].signal_connect("clicked") {
	next_screen = 25
	current_drivelist = AllDrives.new(false, false, false)
	smart_res, smart_available, smart_types, smart_bad, smart_reallocated, smart_seek = smart_short_summary(current_drivelist)
	fill_smart_info(current_drivelist, smart_res, smart_available, smart_types, smart_bad, smart_reallocated, smart_seek, smart_panel)
	moveon = true
	buttonbox.show_all
	if moveon == true
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		# prog_path.push(next_screen) unless prog_path[-1] == next_screen
	end
}

button_failure[1].signal_connect("clicked") {
	next_screen = 31
	moveon = true
	buttonbox.show_all
	if moveon == true
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		# prog_path.push(next_screen) unless prog_path[-1] == next_screen
	end
}

button_failure[2].signal_connect("clicked") {
	next_screen = 32
	moveon = true
	buttonbox.show_all
	if moveon == true
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		# prog_path.push(next_screen) unless prog_path[-1] == next_screen
	end
}

clean_buttons[0].signal_connect("clicked") {
	next_screen = 19
	method = "fast"
	clean_combo[0].active = true
	clean_checkboxes, current_drivelist = fill_clean_list(drive_box, method)
	# clean_pgbars, clean_vtes = fill_clean_pgbars(clean_panel, method, current_drivelist, clean_checkboxes)
	buttonbox.show_all
	moveon = true
	if moveon == true
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		# prog_path.push(next_screen) unless prog_path[-1] == next_screen
	end
	
}

clean_buttons[1].signal_connect("clicked") {
	next_screen = 19
	method = "full"
	clean_combo[1].active = true
	clean_checkboxes, current_drivelist = fill_clean_list(drive_box, method)
	# clean_pgbars, clean_vtes = fill_clean_pgbars(clean_panel, method, current_drivelist, clean_checkboxes)
	buttonbox.show_all
	moveon = true
	if moveon == true
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		# prog_path.push(next_screen) unless prog_path[-1] == next_screen
	end
}

forw_button.signal_connect("clicked") {
	puts prog_path.join(", ")
	moveon = false
	next_screen = page_order(current_page, radio_buttons, radio_failure, skipstart)
	if next_screen == 1 && skipstart == false
		create_swap(swap_sticks[swap_combo.active])
		moveon = true
	elsif next_screen == 7
		clone_source_drives, clone_source_metas = reread_full_drives(rest_source, [])
		moveon = true
	elsif next_screen == 22 
		clone_target_drives, clone_target_metas = reread_full_drives(rest_targets, [ clone_source_drives[rest_source.active] ])
		moveon = true
	elsif next_screen == 23
		msg = ""
		puts clone_source_metas[clone_source_drives[rest_source.active]].last_partend.to_s
		# puts clone_source_drives[rest_source.active]
		# puts clone_source_drives
		# puts rest_source.active
		puts clone_target_metas[clone_target_drives[rest_targets.active]].size.to_s
		moveon = dialog_clone_compare(window, clone_target_metas[clone_target_drives[rest_targets.active]], 
			clone_source_metas[clone_source_drives[rest_source.active]])
		### moveon = false
		if moveon == true
			back_button.sensitive = false
			forw_button.sensitive = false
			buttonbox.hide_all
			restore_finished = false
			screens.each { |s| s.hide_all }
			screens[next_screen].show_all
			prog_path.push(current_page)
			current_page = next_screen
			rest_stop.sensitive = true
			rest_tgt_prog.text = "Klonen läuft..."
			restore_vte.fork_command("ddrescue", ["ddrescue", "--force", 
				clone_source_drives[rest_source.active], clone_target_drives[rest_targets.active]  ])
			restore_vte.signal_connect("child_exited") { 
				restore_finished = true
			}
			while restore_finished == false
				rest_tgt_prog.pulse
				while (Gtk.events_pending?)
					Gtk.main_iteration
				end
				sleep 0.1
			end
			rest_tgt_prog.fraction = 100
			next_screen = 24
			reboot_box.show_all
		end
	elsif next_screen == 19
		method = "fast"
		method = "full" if clean_combo[1].active?
		clean_checkboxes, current_drivelist = fill_clean_list(drive_box, method)
		# clean_pgbars, clean_vtes = fill_clean_pgbars(clean_panel, method, current_drivelist)
		moveon = true
	elsif next_screen == 20
		buttonbox.hide_all
		method = "fast"
		method = "full" if clean_combo[1].active?
		cleancount = 0
		clean_checkboxes.each { |k,v|
			if v.active?
				puts "Clean  " + k
				cleancount += 1
			else
				puts "Ignore " + k
 			end
		}
		clean_pgbars, clean_vtes = fill_clean_pgbars(clean_panel, method, current_drivelist, clean_checkboxes)
		if cleancount < 1
			dialog_empty_clean(window)
			moveon = false
		else	
			moveon = dialog_clean_warn(window, method)
			if moveon == true
				screens.each { |s| s.hide_all }
				screens[next_screen].show_all
				prog_path.push(current_page) unless prog_path[-1] == current_page
				current_page = next_screen
				run_clean(method, clean_pgbars, clean_vtes, current_drivelist, clean_checkboxes, back_button, forw_button)
				reboot_box.show_all
				next_screen = 21
			end
		end
	elsif next_screen == 21 
		moveon = true
	elsif next_screen == 4
		current_drivelist = AllDrives.new(false, false, false)
		sysparts = find_win_sysparts(current_drivelist)
		chntpw_parts = fill_chntpw_combo(chntpw_combo, sysparts) 
		if chntpw_parts.size < 1
			forw_button.sensitive = false
		end
		moveon = true
	elsif next_screen == 12	
		puts chntpw_parts[chntpw_combo.active]
		nt_users = get_nt_users(chntpw_parts[chntpw_combo.active], current_drivelist)
		fill_ntuser_combo(user_combo, nt_users)
		moveon = true
	elsif next_screen == 13
		puts nt_users[user_combo.active][0]
		### system("bash ./run_chntpw.sh")
		run_chntpw(chntpw_parts[chntpw_combo.active], nt_users[user_combo.active], current_drivelist)
		# back_button.sensitive = false
		buttonbox.hide_all
		reboot_box.show_all
		moveon = true
	elsif next_screen == 3
		photorec_drives = fill_photorec_combo(photorec_combo, AllDrives.new(false, false, false))
		forw_button.sensitive = false if photorec_drives.size < 1 
		moveon = true
	elsif next_screen == 8
		moveon = true
	elsif next_screen == 9
		types_selected = false
		photorec_ftypes.each { |t| 
			puts t.active?.to_s
			types_selected = true if t.active? == true
		}
		if types_selected == false
			moveon = dialog_photorec_allornothing(window)
		else
			moveon = true
			current_drivelist = AllDrives.new(false, false, false)
			photorec_targets = fill_photorec_targets(photorec_tgt_combo, current_drivelist, 
				photorec_drives[photorec_combo.active], 1_000_000_000)
			
		end
		if moveon == true
			
		end
	elsif next_screen == 10
		buttonbox.hide_all
		if photorec_targets.size < 1
			dialog_photorec_notarget(window)
			moveon = false
		else
			moveon = true
			screens.each { |s| s.hide_all }
			screens[next_screen].show_all
			prog_path.push(current_page) unless prog_path[-1] == current_page
			current_page = next_screen
			run_photorec(photorec_drives[photorec_combo.active], get_photorec_categories(photorec_ftypes, m_ftypes),
				photorec_targets[photorec_tgt_combo.active], current_drivelist, 
				photorec_vte, forw_button, photorec_prog, window)
			next_screen = 11
			reboot_box.show_all
		end
	elsif next_screen == 5
		@wlan_interface = fill_wlan_combo(wlan_combo, get_networks)
		skip_wlan.active = true if @wlan_interface.nil?
		moveon = true
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		dialog_nonet(window) if @wlan_interface.nil?
		# puts prog_path.join(" - ") + " + " + current_page.to_s
	elsif next_screen == 14 # && prog_path[-1] == 5
		puts "Geeeh... moving to 14"
		puts "Geeeh... current page " + current_page.to_s
		puts "Geeeh... prog path " + prog_path.join(", ")
		puts "Geeeh... " +  skip_wlan.active?.to_s
		if skip_wlan.active? == false && check_network == false && ( prog_path.include?(5) || current_page == 5 )
			puts "Geeeh... connecting!"
			window_net_connect(window, wlan_combo.active_text, wlan_key.text, [ forw_button, back_button] )
			screens.each { |s| s.hide_all }
			screens[next_screen].show_all
			prog_path.push(current_page) unless prog_path[-1] == current_page
			current_page = next_screen
			puts prog_path.join(" - ") + " + " + current_page.to_s
			run_virus_signature_update(upd_vte, upd_progbar, [ forw_button, back_button], "kaspersky")
		elsif skip_wlan.active? == true
			next_screen = 15
		else
			buttonbox.hide_all
			screens.each { |s| s.hide_all }
			screens[next_screen].show_all
			prog_path.push(current_page) unless prog_path[-1] == current_page
			current_page = next_screen
			puts prog_path.join(" - ") + " + " + current_page.to_s
			run_virus_signature_update(upd_vte, upd_progbar, [ forw_button, back_button], "kaspersky")
			next_screen = 35
			buttonbox.show_all
		end
		moveon = true
	elsif next_screen == 15
		buttonbox.hide_all
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		run_virusscan(scan_vte, scan_progbar, [ forw_button, back_button], "kaspersky", virus_archive, @virus_delete, @virus_kill)
		next_screen = page_order(current_page, radio_buttons, radio_failure, skipstart)
		virus_list_field.buffer.text = File.new("/tmp/kaspersky_infected.log", "r").read
		virus_del_summary.text = virus_human_stats
		reboot_box.show_all
		moveon = true
	elsif next_screen == 25
		current_drivelist = AllDrives.new(false, false, false)
		smart_res, smart_available, smart_types, smart_bad, smart_reallocated, smart_seek = smart_short_summary(current_drivelist)
		fill_smart_info(current_drivelist, smart_res, smart_available, smart_types, smart_bad, smart_reallocated, smart_seek, smart_panel)
		moveon = true
	elsif next_screen == 26
		smart_stop.sensitive = true
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		current_drivelist = AllDrives.new(false, false, false)
		buttonbox.hide_all
		@bad_drives = run_smart_check(current_drivelist, smart_pgbar, [ forw_button, back_button])
		smart_src_checks, smart_tgt_drives, smart_tgt_combos = fill_smart_clone_panel(smart_clone_panel, current_drivelist, @bad_drives)
		next_screen = 30
		next_screen = 27 if @bad_drives.size > 0 || @simulate.include?("smartfail")
		buttonbox.show_all
		moveon = true
	elsif next_screen == 27
		buttonbox.show_all
		moveon = true
	elsif next_screen == 28
		moveon = false
		src_found = false
		smart_targets = Hash.new
		smart_src_checks.each{ |k,v|
			src_found = true if v.active?
		}
		if src_found == false
			smart_no_src_dialog(window)
			moveon = false
		elsif smart_tgt_drives.to_a[0][1].size < 1
			smart_no_tgt_dialog(window)
			moveon = false
		else
			moveon = true
			smart_src_checks.each { |k,v|
				if v.active? == true
					src = k
					tgt = smart_tgt_drives[k][smart_tgt_combos[k].active]
					puts "cloning " + src + " to " +  tgt
					if smart_tgt_not_empty(tgt, current_drivelist)
						cont = smart_tgt_not_empty_dialog(window, tgt)
						smart_targets[src] = tgt if cont == true
					elsif smart_targets.has_value?(tgt)
						smart_mult_tgt_dialog(window)
						moveon = false
					else
						smart_targets[src] = tgt
					end
				end
			}
		
		end
		if moveon == true
			screens.each { |s| s.hide_all }
			screens[next_screen].show_all
			prog_path.push(current_page) unless prog_path[-1] == current_page
			current_page = next_screen
			puts prog_path.join(" - ") + " + " + current_page.to_s
			clone_stop.sensitive = true
			buttonbox.hide_all
			smart_run_ddrescue(clone_vte, clone_pgbar, smart_targets, [forw_button, back_button] )
			reboot_box.show_all
			next_screen = 29
		end
	elsif next_screen == 30
		current_drivelist = AllDrives.new(false, false, false)
		smart_run_ntfsfix(current_drivelist)
		moveon = true
	elsif next_screen == 34
		continue = dialog_bootsect_warn(window)
		if continue == true
			current_drivelist = AllDrives.new(false, false, false)
			bootsect_success = run_bootsect_restore(current_drivelist)
			next_screen = 33 if bootsect_success == true
		end
		buttonbox.hide_all
		reboot_box.show_all
		moveon = true
	else
		moveon = true
	end
	if moveon == true
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		# prog_path.push(next_screen) unless prog_path[-1] == next_screen
	end
	if prog_path[-1] == 30
		run_kexec_memtest
	end
}

rest_src_reread.signal_connect("clicked") {
	clone_source_drives = reread_full_drives(rest_source, [])
}

rest_tgt_reread.signal_connect("clicked") {
	clone_target_drives = reread_full_drives(rest_targets, [ clone_source_drives[rest_source.active] ])
}

photorec_reread.signal_connect("clicked") {
	current_drivelist = AllDrives.new(false, false, false)
	photorec_drives = fill_photorec_combo(photorec_combo, current_drivelist)
}

photorec_tgt_reread.signal_connect("clicked") {
	current_drivelist = AllDrives.new(false, false, false)
	photorec_targets = fill_photorec_targets(photorec_tgt_combo, current_drivelist, photorec_drives[photorec_combo.active])
}

smart_stop.signal_connect("clicked") {
	current_drivelist = AllDrives.new(false, false, false)
	current_drivelist.drive_list.each { |k,v|
		system("smartctl -X " + k)
	}
	smart_pgbar.text = "Der Selbsttest wird abgebrochen."
	smart_stop.sensitive = false
}

smart_tgt_reread.signal_connect("clicked") {
	current_drivelist = AllDrives.new(false, false, false)
	# smart_src_checks, smart_tgt_drives, smart_tgt_combos = fill_smart_clone_panel(smart_clone_panel, current_drivelist, @bad_drives)
	smart_tgt_drives = update_smart_clone_panel(smart_tgt_combos, current_drivelist, @bad_drives)
}

swap_button.signal_connect("clicked") {
	current_drivelist = AllDrives.new(false, false, false)
	swap_sticks = reread_swap_drives(current_drivelist, swap_combo)
	if swap_sticks.size > 0
		forw_button.sensitive = true
		back_button.sensitive = true 
	end
}

clone_stop.signal_connect("clicked") {
	pid_to_kill = ` cat /var/run/lesslinux/ddrescue.pid `
	system("kill -9 " + pid_to_kill)
	system("killall -9 ddrescue")
	system("rm /var/run/lesslinux/ddrescue.log")
	system("rm /var/run/lesslinux/ddrescue.pid")
	clone_stop.sensitive = false
}

rest_stop.signal_connect("clicked") {
	rest_stop.sensitive = false
	system("killall ddrescue")
	sleep 2
	system("killall -9 ddrescue")
}

Gtk.main
